<?php

function is_localhost()
{
    $whitelist = array('127.0.0.1', '::1');
    if (in_array($_SERVER['REMOTE_ADDR'], $whitelist)) {
        return TRUE;
    } else {
        return FALSE;
    }
}

function getDateTime($time = 0, $form = "dtLong")
{
    switch ($form) {
        case "dtVLong":
            $strform = "D, jS F, Y g:i:s A (\G\M\T O)";
            break;
        case "dtLong":
            $strform = "D, jS F, Y g:i A";
            break;
        case "dtShort":
            $strform = "jS M, Y g:i A";
            break;
        case "dtMin":
            $strform = "j-n-y G:i";
            break;
        case "dLong":
            $strform = "D, jS F Y";
            break;
        case "dShort":
            $strform = "j-M-Y";
            break;
        case "dMin":
            $strform = "j-n-y";
        case "dOnly":
            $strform = "Y-n-j";
            break;
        case "tLong":
            $strform = "G:i:s (\G\M\T O)";
            break;
        case "tShort":
            $strform = "G:i";
            break;
        case "mySQL":
            $strform = "Y-m-d H:i:s";
            break;
        case "dAmericano":
            $strform = "F d, Y";
            break;
        default:
            $strform = "j-M-Y g:ia";
    }
    if ($time == 0) {
        $formated_time = date($strform);
    } else {
        $time = strtotime($time);
        $formated_time = date($strform, $time);
    }
    return $formated_time;
}


function calculateDuration($stime, $etime)
{
    $dateDiff = intval((strtotime($stime) - strtotime($etime)) / 60);

    $hours = intval($dateDiff / 60);
    $minutes = $dateDiff % 60;
    return $hours . ' hrs, ' . $minutes . ' min';
}


function formate_date_days($timestamp)
{
    $date = date('d/m/Y', strtotime($timestamp));

    if ($date == date('d/m/Y')) {
        $date = 'Today ' . date('h:m A', strtotime($timestamp));
    } elseif ($date == date('d/m/Y', strtotime("-1 days"))) {
        $date = 'Yesterday ' . date('h:m A', strtotime($timestamp));
    } else {
        $date = date('D, d M, ', strtotime($timestamp)) . date('h:m A', strtotime($timestamp));
    }
    return $date;
}

// To Prevent SQL injection
function GetSQLValueString($theValue, $theType, $theDefinedValue = "", $theNotDefinedValue = "")
{
    $theValue = get_magic_quotes_gpc() ? stripslashes($theValue) : $theValue;

    $theValue = function_exists("mysql_real_escape_string") ? mysql_real_escape_string($theValue) : mysql_escape_string($theValue);

    switch ($theType) {
        case "text":
            $theValue = ($theValue != "") ? "'" . $theValue . "'" : "NULL";
            break;
        case "long":
        case "int":
            $theValue = ($theValue != "") ? intval($theValue) : "NULL";
            break;
        case "double":
            $theValue = ($theValue != "") ? "'" . doubleval($theValue) . "'" : "NULL";
            break;
        case "date":
            $theValue = ($theValue != "") ? "'" . $theValue . "'" : "NULL";
            break;
        case "defined":
            $theValue = ($theValue != "") ? $theDefinedValue : $theNotDefinedValue;
            break;
    }
    return $theValue;
}

function get_domain($url)
{
    $pieces = parse_url($url);
    $domain = isset($pieces['host']) ? $pieces['host'] : '';
    if (preg_match('/(?P<domain>[a-z0-9][a-z0-9\-]{1,63}\.[a-z\.]{2,6})$/i', $domain, $regs)) {
        return $regs['domain'];
    }
    return false;
}

function get_host()
{
    if ($host = $_SERVER['HTTP_X_FORWARDED_HOST']) {
        $elements = explode(',', $host);

        $host = trim(end($elements));
    } else {
        if (!$host = $_SERVER['HTTP_HOST']) {
            if (!$host = $_SERVER['SERVER_NAME']) {
                $host = !empty($_SERVER['SERVER_ADDR']) ? $_SERVER['SERVER_ADDR'] : '';
            }
        }
    }

    // Remove port number from host
    $host = preg_replace('/:\d+$/', '', $host);

    return trim($host);
}

function round2dp($number)
{
    return number_format((float)$number, 2, '.', ',');
}

function col_index($string, $line)
{
    $found = 0;
    $i = 0;
    while ($found == 0 && $i < count($line)) {
        if ($line[$i] == $string) {
            $found = 1;
        } else {
            $i = $i + 1;
        }
    }
    if ($found == 0)
        return -1;
    else
        return $i;
}

function parseTree($root, $arr)
{
    $return = array();
    // Traverse the tree and search for direct children of the root
    foreach ($arr as $child => $parent) {
        // A direct child is found
        if ($parent == $root) {
            // Remove item from tree (we don't need to traverse this again)
            unset($arr[$child]);
            // Append the child into result array and parse it's children
            $return[] = array(
                'name' => $child,
                'children' => parseTree($child, $arr)
            );
        }
    }
    return empty($return) ? null : $return;
}

function printTree($arr)
{
    if (!is_null($arr) && count($arr) > 0) {
        echo '<ul>';
        foreach ($arr as $node) {
            echo "<li>" . $node['sect_name'] . "";
            if (array_key_exists('children', $node)) {
                printTree($node['children']);
            }
            echo '</li>';
        }
        echo '</ul>';
    }
}

function is_serialized($data)
{
    if (!is_string($data)) {
        return false;
    }
    $data = trim($data);
    if ('N;' == $data) {
        return true;
    }
    if (!preg_match('/^([adObis]):/', $data, $badions)) {
        return false;
    }
    switch ($badions[1]) {
        case 'a':
        case 'O':
        case 's':
            if (preg_match("/^{$badions[1]}:[0-9]+:.*[;}]\$/s", $data)) {
                return true;
            }
            break;
        case 'b':
        case 'i':
        case 'd':
            if (preg_match("/^{$badions[1]}:[0-9.E-]+;\$/", $data)) {
                return true;
            }
            break;
    }
    return false;
}

function displayPaginationBelow($per_page, $page, $sql, $page_url)
{
    DB::query($sql);
    $total = DB::count();
    $adjacents = "2";

    $page = ($page == 0 ? 1 : $page);
    $start = ($page - 1) * $per_page;

    $prev = $page - 1;
    $next = $page + 1;
    $setLastpage = ceil($total / $per_page);
    $lpm1 = $setLastpage - 1;

    $setPaginate = "";
    if ($setLastpage > 1) {
        $setPaginate .= "<ul class='setPaginate'>";
        $setPaginate .= "<li class='setPage'>Page $page of $setLastpage</li>";
        if ($setLastpage < 7 + ($adjacents * 2)) {
            for ($counter = 1; $counter <= $setLastpage; $counter++) {
                if ($counter == $page)
                    $setPaginate .= "<li><a class='current_page'>$counter</a></li>";
                else
                    $setPaginate .= "<li><a href='{$page_url}page=$counter'>$counter</a></li>";
            }
        } elseif ($setLastpage > 5 + ($adjacents * 2)) {
            if ($page < 1 + ($adjacents * 2)) {
                for ($counter = 1; $counter < 4 + ($adjacents * 2); $counter++) {
                    if ($counter == $page)
                        $setPaginate .= "<li><a class='current_page'>$counter</a></li>";
                    else
                        $setPaginate .= "<li><a href='{$page_url}page=$counter'>$counter</a></li>";
                }
                $setPaginate .= "<li class='dot'>...</li>";
                $setPaginate .= "<li><a href='{$page_url}page=$lpm1'>$lpm1</a></li>";
                $setPaginate .= "<li><a href='{$page_url}page=$setLastpage'>$setLastpage</a></li>";
            } elseif ($setLastpage - ($adjacents * 2) > $page && $page > ($adjacents * 2)) {
                $setPaginate .= "<li><a href='{$page_url}page=1'>1</a></li>";
                $setPaginate .= "<li><a href='{$page_url}page=2'>2</a></li>";
                $setPaginate .= "<li class='dot'>...</li>";
                for ($counter = $page - $adjacents; $counter <= $page + $adjacents; $counter++) {
                    if ($counter == $page)
                        $setPaginate .= "<li><a class='current_page'>$counter</a></li>";
                    else
                        $setPaginate .= "<li><a href='{$page_url}page=$counter'>$counter</a></li>";
                }
                $setPaginate .= "<li class='dot'>..</li>";
                $setPaginate .= "<li><a href='{$page_url}page=$lpm1'>$lpm1</a></li>";
                $setPaginate .= "<li><a href='{$page_url}page=$setLastpage'>$setLastpage</a></li>";
            } else {
                $setPaginate .= "<li><a href='{$page_url}page=1'>1</a></li>";
                $setPaginate .= "<li><a href='{$page_url}page=2'>2</a></li>";
                $setPaginate .= "<li class='dot'>..</li>";
                for ($counter = $setLastpage - (2 + ($adjacents * 2)); $counter <= $setLastpage; $counter++) {
                    if ($counter == $page)
                        $setPaginate .= "<li><a class='current_page'>$counter</a></li>";
                    else
                        $setPaginate .= "<li><a href='{$page_url}page=$counter'>$counter</a></li>";
                }
            }
        }

        if ($page < $counter - 1) {
            $setPaginate .= "<li><a href='{$page_url}page=$next'>Next</a></li>";
            $setPaginate .= "<li><a href='{$page_url}page=$setLastpage'>Last</a></li>";
        } else {
            $setPaginate .= "<li><a class='current_page'>Next</a></li>";
            $setPaginate .= "<li><a class='current_page'>Last</a></li>";
        }

        $setPaginate .= "</ul>\n";
    }

    return $setPaginate;
}

function RemoveSpecialChar($str)
{

    // Using str_ireplace() function
    // to replace the word
    $res = str_ireplace(array('\'', '"',
        ',', ';', '<', '>', '(', ')'), '', $str);


    // Remove - from begining of string
    $res = ltrim($res, '-');
    // returning the result
    return $res;
}


function CategoryTreeSelectCOA(&$output = null, $parent = 0, $indent = null, $selectID = 0)
{
    $r = DB::query("SELECT * FROM coa WHERE parent_id='" . $parent . "'");
    foreach ($r as $c) {
        $output .= '<option value="' . $c['coa_id'] . '"';
        if ($c['coa_id'] == $selectID) {
            $output .= 'SELECTED';
        }
        $output .= '>' . $indent . $c['name'] . "</option>";
        if ($c['coa_id'] != $parent) {
            // in case the current category's id is different that $parent
            // we call our function again with new parameters
            CategoryTreeSelectCOA($output, $c['coa_id'], $indent . "&nbsp;&nbsp;&nbsp;&nbsp;", $selectID);
        }
    }
    // return the list of categories
    return $output;
}

function display_with_children_coa($parentRow, $level)
{
    if ($level != 0) {
        echo '<li data-id="child_node_' . $level . '"><a href="#">' . $parentRow['name'];
        echo '</a>&nbsp;&nbsp;';
        echo '&nbsp;<strong><small>[Balance: $' . $parentRow['balance'] . ']</small></strong>';
        echo '&nbsp;<small><a title="Edit"   data-balance="' . $parentRow['balance'] . '"  data-parent="' . $parentRow['parent_id'] . '" data-name="' . $parentRow['name'] . '" data-id="' . $parentRow['coa_id'] . '"  data-toggle="modal" data-target="#editModal" class="text-dark edit" href="javascript:;"><i class="fas fa-pencil-alt"></i>_Edit</a></small>';

    }
    // if your id column is integer, you don't need the quotation mark
    $result = DB::query("SELECT * FROM coa WHERE parent_id='" . $parentRow['coa_id'] . "'");
    if (DB::count() != 0) {
        echo '<ul class="category-tree">';
        // use the fetch_assoc to get an associative array
        foreach ($result as $row) {
            display_with_children_coa($row, $level + 1);
        }
        echo '</ul>';
    }
    echo '</li>';
}


function get_property_name($properties_id)
{
    return DB::queryFirstField("SELECT `name` FROM properties WHERE properties_id = '" . (int)$properties_id . "'");
}

function get_coa_name($coa_id)
{
    return DB::queryFirstField("SELECT `name` FROM coa WHERE coa_id = '" . (int)$coa_id . "'");
}

function do_account_transaction($amount, $coa_id, $type = 'expense')
{
    if ($type == 'expense') {
        DB::query("UPDATE coa SET balance = (balance-" . $amount . ") WHERE coa_id='" . $coa_id . "'");
    } else {
        DB::query("UPDATE coa SET balance = (balance+" . $amount . ") WHERE coa_id='" . $coa_id . "'");
    }
}